#ifndef BALL_H_
#define BALL_H_

#include "model.h"

#define BALL_SCALE 0.25
#define BALL_X_VEC_MIN 4
#define BALL_X_VEC_MAX 5
#define BALL_Y_VEC_MIN 5
#define BALL_Y_VEC_MAX 6
#define BALL_X_SPIN_MIN 90
#define BALL_X_SPIN_MAX 240
#define BALL_Y_SPIN_MIN 90
#define BALL_Y_SPIN_MAX 240
#define BALL_Z_SPIN_MIN 90
#define BALL_Z_SPIN_MAX 240

class BALL
{
  public:
    void InitBall(void);
    //Initializes the ball and loads the mesh data.
    void Display(unsigned char alpha);
    //Displays the ball.
      //alpha: The transparancy to display the ball at.
    void Update(void);
    //Updates the variables for the ball.
  private:
    MODEL ball;
    void ResetLeftSide(void);
    void ResetRightSide(void);
    float x_vec, y_vec;
    float y_accel;
    float x_spin, y_spin, z_spin;
};

#endif
