#ifndef _BUTTERFLY_H_
#define _BUTTERFLY_H_

class BUTTERFLY
{
  public: 
    void Draw(void);
    //Draws a butterfly.
    void SetYRot(float y);
    //Sets the y rotation for the butterfly.
    void SetTranslation(float x, float y, float z);
    //Sets the translation for the butterfly.
    void SetScale(float scaling);
    //Sets up the scaling.
    void SetUp(float wings_up);
    //Sets how for up to draw the wings.
      //wings_up: A value between 0 - 1 that tells how up the wings are.
    void AddYRot(float y);
    //Adds to the current Y Rotation.
    void AddTranslation(float x, float y, float z);
    //Adds to the current translation
    void AddUp(float wings_up);
    //Adds to the wings.
    float GetUp(void);
    //Returns the up value for the wings.
    float GetX(void);
    float GetY(void);
    float GetZ(void);
  private:
    void FixUp(void);
    //Fixes up if it's greater than 1.
    float trans_x, trans_y, trans_z;
    float rot_y;
    float scale;
    float up;
};

#endif
