#ifndef _DEMOLOOP_H_
#define _DEMOLOOP_H_

#include "snow.h"
#include "leaves.h"
#include "ball.h"
#include "butterflies.h"

#define FADE_IN_SPEED 0.3
#define FADE_WHITE_IN_SPEED 1

enum SEASONS { SPRING = 0, SUMMER, FALL, WINTER };

class DEMOLOOP
{
  public:
    void RunLoop(void);
  private:
    BALL ball;
    SNOW snow;
    LEAVES leaves;
    BUTTERFLIES butterflies;
    void ShowSpring(unsigned char alpha);
    void ShowSummer(unsigned char alpha);
    void ShowFall(unsigned char alpha);
    void ShowWinter(unsigned char alpha);
    void FadeOut(float amount);
    void FadeWhite(float amount);
    void NextScene(void);
    bool fading_out, fading_in;
    bool fading_white_in, fading_white_out;
    float fade_alpha, fade_white_alpha;
    bool quit;
    SEASONS state;
};

void TriggerNextScene(void);

#endif
